;teplomr pro udirnu s DS18B20_12b zobrazen na LCD
;Vagner Vlastimil
;vagnervlastimil@seznam.cz
pause 2000              ;asov prodleva
#picaxe 08m2            ;typ procesoru pro peklada
low 2                   ;pin .2 na logickou "0"
b9 = 0                  ;b9 hodnota pro zapnut,vypnut rel RE1 signalizace 
if pin4 = 0 then        ;pokud je PIN C.4 log "0" provoz teplomr
read 0,b9               ;naten hodnoty v b9 z EEPROM
serout c.0,n2400,($FE,$01) ;inicializace LCD vymazani LCD
pause 200               ;asov prodleva 
serout c.0,n2400,($FE,$80,"Teplota v udirne")  ;zobrazen na 1 dku LCD
goto start              ;skok na nvt start provot teplomr  
else                    ;volba                        
goto zadej              ;skok na navt programovn
endif                   ;konec pkazu IF    
zadej:                  ;nvt zadej:   
serout c.0,n2400,("sepnuti signalizace",13,10) ;zadej hodnotu b9
pause 2000                                           ;asov prodleva 
serin c.3,n2400,b9                                   ;pjem hodnoty do b9
write 0,b9                                           ;zpis hodnoty b9 do EEPROM
pause 1000                                           ;asov prodleva 
end                                                  ;po zapsn hodnoty do EEPROM se program ukon
start:                        ;zatek programu   
readtemp12 c.1,w0             ;naten hodnoty z DS18B20
b4=w0/256/128                 ;vpoet zda je teplota kladn nebo mnusov
if b4=0 then kladna           ;pokud je teplota kladn skok na nvst kladn
w0=w0^$FFFF+1                 ;vpoet teploty zda je mnusov
kladna:                       ;nvt kladn
w3=w0*6                       ;vpoet 
w0=w0*25/100                  ;vpoet
w3=w3+w0                      ;vpoet
b2=w3/100                     ;vpoet
b3=w3//100                    ;vpoet
b5=b3/10                      ;vpoet
b8=b3//10                     ;vpoet
if b4=0 then zobraz_plus      ;pokud je signln bit "0" skok na nvt zobraz_plus
serout c.0,n2400,($FE,$C2,"- ",#b2,".",#b5,#b8," stC",32)  ;zobrazen mnusov teploty
pause 1000                    ;asov prodleva 
goto start                    ;skok na nvt start
zobraz_plus:                  ;nvt zobraz_plus
serout c.0,n2400,($FE,$C2,"+ ",#b2,".",#b5,#b8," stC",32)  ;zobrazen kladn teploty
if b2<=b9 then high 2 else low 2 endif                     ;zapnut,vypnut rele signalizace dle teploty
pause 1000                    ;asov prodleva
goto start                    ;skok na nvt start
end